#include <sourcemod>
#include <sdktools>
#include <cstrike>
#pragma semicolon 1
#define PLUGIN_VERSION "1.0"

// ConVars
ConVar sEnable;
ConVar sRoundTime;
ConVar sWhoWin;
ConVar sRoundEndDelay;

Handle RoundTimer;
public Plugin myinfo = 
{
	name = "[CSS/CSGO] SLAYER Force Round End",
	author = "SLAYER",
	description = "Force round end at the correct round time limit when there was no objective in the Map",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=293943"
};

public void OnPluginStart()
{
	sEnable = CreateConVar("forceroundend_enable", "1", "Enable/Disable SLAYER Force Round End Plugin? (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sWhoWin = CreateConVar("forceroundend_who_win", "0", "Who will win when the Round End Forcefully at Round Timelimit? (0 = Draw, 1 = Terrorist, 2 = Counter-Terrorist)", FCVAR_NOTIFY, true, 0.0, true, 2.0);
	sRoundEndDelay  = CreateConVar("forceroundend_end_delay", "4.0", "How many seconds should delay after the force round End and before the New Round?", FCVAR_NOTIFY, true, 1.0);
	
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	HookEvent("round_end", Event_OnRoundEnd, EventHookMode_PostNoCopy);
	HookEvent("bomb_planted", Event_BombPlanted);
	
	AutoExecConfig(true, "SLAYER_ForceRoundEnd");
	
}

public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	if(sEnable.BoolValue)
	{
		if(RoundTimer != null)delete RoundTimer;
		sRoundTime = FindConVar("mp_roundtime");
		RoundTimer = CreateTimer((sRoundTime.FloatValue*60.0)+0.5, RoundTimerHandler);
		
	}
}

public void Event_OnRoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	if(sEnable.BoolValue)
	{
		if(RoundTimer != null)delete RoundTimer;
		
	}
}

// Delete the timer if bomb planted
public Action Event_BombPlanted(Handle event, const char [] name, bool dontBroadcast)
{
	if(sEnable.BoolValue)if(RoundTimer != null)delete RoundTimer;
}

public Action RoundTimerHandler(Handle timer)
{
	RoundTimer = null;
	if(sEnable.BoolValue)
	{
		if(sWhoWin.IntValue == 0)
		{
			CS_TerminateRound(sRoundEndDelay.FloatValue, CSRoundEnd_Draw);
		}
		else if(sWhoWin.IntValue == 1){
			CS_TerminateRound(sRoundEndDelay.FloatValue, CSRoundEnd_TerroristWin);
			int TScore = GetTeamScore(2);
			SetTeamScore(2, TScore+1);
		}
		else if(sWhoWin.IntValue == 2){
			CS_TerminateRound(sRoundEndDelay.FloatValue, CSRoundEnd_CTWin);
			int CTScore = GetTeamScore(3);
			SetTeamScore(3, CTScore+1);
		}
	}
	return Plugin_Continue;
}